Unit MNA1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNA1R(F :Func_F1; var A :Real; var B :Real; var C :Real;
                var FA :Real; var FB :Real; var FC :Real;
                var IFLAG :Integer; NMAX :Integer);

implementation

procedure MNA1R(F :Func_F1; var A :Real; var B :Real; var C :Real;
                var FA :Real; var FB :Real; var FC :Real;
                var IFLAG :Integer; NMAX :Integer);
var
I :Integer;
DUM,R,Q,U,ULIM,FU :Real;
const
GOLD :Real = 1.618034;
GLIMIT :Real = 100.0;
TINY :Real = 1.0E-5;
label
_10,_20,_30,_40,_50,_60,_70,_80,_100,_90;
begin
IFLAG := 0;
FA := F(A);
FB := F(B);
if ( FB <= FA ) 
 then goto _10;
DUM := A;
A := B;
B := DUM;
DUM := FB;
FB := FA;
FA := DUM;
_10:
C := B+GOLD*(B-A);
FC := F(C);
for I:=1 to NMAX do
 begin
  _MNA1RR.elm1 := I;
  if ( FB < FC ) 
   then goto _100;
  R := (B-A)*(FB-FC);
  Q := (B-C)*(FB-FA);
  U := B-((B-C)*Q-(B-A)*R)/(2.0*Sign(EMax1(Abs(Q-R),TINY),Q-R));
  ULIM := B+GLIMIT*(C-B);
  if ( (B-U)*(U-C) <= 0.0 ) 
   then goto _40;
  FU := F(U);
  if ( FU >= FC ) 
   then goto _20;
  A := B;
  FA := FB;
  B := U;
  FB := FU;
  goto _80;
_20:
  if ( FU <= FB ) 
   then goto _30;
  C := U;
  FC := FU;
  goto _80;
_30:
  U := C+GOLD*(C-B);
  FU := F(U);
  goto _70;
_40:
  if ( (C-U)*(U-ULIM) <= 0.0 ) 
   then goto _50;
  FU := F(U);
  if ( FU >= FC ) 
   then goto _70;
  B := C;
  C := U;
  U := C+GOLD*(C-B);
  FB := FC;
  FC := FU;
  FU := F(U);
  goto _70;
_50:
  if ( (U-ULIM)*(ULIM-C) < 0.0 ) 
   then goto _60;
  U := ULIM;
  FU := F(U);
  goto _70;
_60:
  U := C+GOLD*(C-B);
  FU := F(U);
_70:
  A := B;
  B := C;
  C := U;
  FA := FB;
  FB := FC;
  FC := FU;
_80:
 end;
goto _90;
_100:
IFLAG := 1;
_90:
end;

end.
